<?php

namespace DSERS_WOO_ALI\API;

use \DSERS_WOO_ALI\Common\DSERS_WOO_ALI_COMMON_Requirements as Cmr;
use \DSERS_WOO_ALI\Common\DSERS_WOO_ALI_COMMON_Plugin as Plg;

class DSERS_WOO_ALI_API_Admin {
    /**
	 * The plugin instance.
	 *
	 * @var Plugin
	 */
	private $plugin;

	/**
	 * Sets up initial instance properties
	 *
	 * @param \DSERS_WOO_ALI\DSERS_WOO_ALI_Plugin $plugin This plugin's instance.
	 * @return void
	 */
	public function __construct( \DSERS_WOO_ALI\DSERS_WOO_ALI_Plugin $plugin) {
		$this->plugin = $plugin;
    }
    
    public function ds_woo_getRequireStatus() {
        check_ajax_referer( 'dsers-get-site-status-nonce', 'nonce');
        $status = Cmr::ds_woo_getRequirementsStatus();
		wp_send_json_success(array(
			'status' => $status,
		));
	}
	
	public function ds_woo_getPluginStatus() {
		check_ajax_referer( 'dsers-get-plugin-status-nonce', 'nonce');
		$status = Plg::ds_woo_getDSersPluginStatus();
		wp_send_json_success(array(
			'status' => $status,
		));
	}

	public function ds_woo_disconnectDSers() {

	}

    public function run() {
		add_action('wp_ajax_dsers_site_status',array($this,'ds_woo_getRequireStatus'));
		add_action('wp_ajax_dsers_plugin_status',array($this,'ds_woo_getPluginStatus'));
    }
}