<?php

namespace DSERS_WOO_ALI\Activation;

class DSERS_WOO_ALI_ACTIVATION_Requirement {
    private static $object = null;
    private $plugin;
    
	public function __construct( \DSERS_WOO_ALI\DSERS_WOO_ALI_Plugin $plugin) {
		self::$object = $this;
		$this->plugin = $plugin;
    }
    
    /** 
     * check woocommerce plugin is installed and activated.
     * 
     * **/
    private function ds_woo_isWooCommerceActiveted() {
        if (is_plugin_active('woocommerce/woocommerce.php')) {
			return true;
		}

		return false;
    }

    private function ds_woo_deactivePlugin() {
        if (current_user_can('activate_plugins') && is_plugin_active(self::$object->plugin->ds_woo_getPrefix())) {
			deactivate_plugins(plugin_basename(self::$object->plugin->ds_woo_getPrefix()));
			if ( isset( $_GET['activate'] ) ) {
				unset( $_GET['activate'] );
			}
		}
    }

    public function ds_woo_disablePluginOnRequirementFail() {
        if (!self::$object->ds_woo_isWooCommerceActiveted()) {
            self::$object->ds_woo_deactivePlugin();
            add_action( "admin_head", function(){
                    // 需要发送通知告知用户 DSers 插件被disable
                    self::ds_woo_notifyUser('DSers Plugin', 'WooCoommerce needs to be installed and activated before you can activate DSers plugin.');
            });
        }
    }

    public static function ds_woo_notifyUser( $title, $message) {
		echo '<div class="error">
			    <p>' .
				 esc_html__($title)
			  . '</p>
			    <p>
		         <b>Error: </b>' . esc_html__($message)
			  . '</p>
		     </div>';
	}

    public function run() {
        add_action('admin_init',array($this,'ds_woo_disablePluginOnRequirementFail'));
    }
}