<?php

namespace DSERS_WOO_ALI\Common;

class DSERS_WOO_ALI_COMMON_Plugin
{

	/**
	 * The plugin instance.
	 *
	 * @var Plugin
	 */
	private $plugin;

	private static $object = null;

	/**
	 * Sets up initial instance properties
	 *
	 * @param \DSERS_WOO_ALI\DSERS_WOO_ALI_Plugin $plugin This plugin's instance.
	 * @return void
	 */
	public function __construct(\DSERS_WOO_ALI\DSERS_WOO_ALI_Plugin $plugin)
	{
		self::$object = $this;
		$this->plugin = $plugin;
	}

	public static function ds_woo_getDSersPluginStatus()
	{
		return array(
			'connected' => get_option('dsers_connected', false)
		);
	}

	private function ds_woo_getConsumerSecretAndKey()
	{
		global $wpdb;

		return $wpdb->get_row($wpdb->prepare(
			"SELECT consumer_secret
             FROM `{$wpdb->prefix}woocommerce_api_keys`
             WHERE description LIKE %s ORDER BY key_id DESC",
			'%' . $wpdb->esc_like('DSers') . '%'
		));
	}

	private function ds_woo_getProductCategory($category_id)
	{
		global $wpdb;

		$tableName = $wpdb->prefix . 'terms';
		return $wpdb->get_row($wpdb->prepare('select * from `%1$s` where term_id = "%2$s"', $tableName, $category_id));
	}

	public static function ds_woo_isReadyConnected()
	{
		$ks = self::$object->ds_woo_getConsumerSecretAndKey();
		// if (empty($ks)) {
		// 	return "";
		// }

		$rep = wp_remote_request(
			sprintf(
				self::$object->plugin->ds_woo_getApiURL() . 'woo/plugin?secret=%s&domain=%s',
				$ks->consumer_secret,
				self::$object->plugin->ds_woo_getHomeDomain()
			),
			array(
				'method' => 'GET',
			)
		);

		return json_decode(wp_remote_retrieve_body($rep));
	}

	public function run()
	{
	}
}
