<?php

namespace DSERS_WOO_ALI;

class DSERS_WOO_ALI_EMAIL
{
    public function DSERS_WOO_ALI_EMAIL_REGISTER_ROUTES()
    {
        $version = 'v1';
        $namespace = 'dsers/' . $version;

        register_rest_route($namespace, '/email', array(
            array(
                'methods' => 'GET',
                'callback' => array($this, 'DSERS_WOO_ALI_EMAIL_Get_Status'),
                'permission_callback' => '__return_true'
            ),
            array(
                'methods' => 'POST',
                'callback' => array($this, 'DSERS_WOO_ALI_EMAIL_Send_Email'),
                'permission_callback' => '__return_true'
            ),
        ));
    }

    public function DSERS_WOO_ALI_EMAIL_Get_Status(\WP_REST_Request $request)
    {
        // $params = $request->get_params();
        $response = array(
            'email' => true,
        );
        return new \WP_REST_Response($response, 200);
    }

    public function DSERS_WOO_ALI_EMAIL_Send_Email(\WP_REST_Request $request)
    {
        $data = $request->get_json_params();
        $secret = $data['secret'];
        $sec = $this->DSERS_WOO_ALI_EMAIL_Get_WC_Secret();
        if ($secret == '' || $sec->consumer_secret != $secret) {
            $resp = array(
                'email' => false,
            );
            return new \WP_REST_Response($resp, 401);
        }

        $to = $data['to'];
        $subject = 'Your ' . get_bloginfo('name') . ' order is now complete';
        $message = $data['message'];
        $headers = array('Content-Type: text/html; charset=UTF-8');
        $attachments = '';
        $result = $this->DSERS_WOO_ALI_EMAIL_WP_MAIL($to, $subject, $message, $headers, $attachments);

        $response = array(
            'email' => $result,
        );
        return new \WP_REST_Response($response, 200);
    }

    public function DSERS_WOO_ALI_EMAIL_WP_MAIL($to, $subject, $message, $headers, $attachments)
    {
        add_filter('wp_mail_from_name', array($this, 'DSERS_WOO_ALI_EMAIL_WPMAIL_From_Name'));
        add_filter('wp_mail_content_type', array($this, 'DSERS_WOO_ALI_EMAIL_WPDOCS_SET_HTML_MAIL_CONTENT_TYPE'));
        $result = wp_mail($to, $subject, $message, $headers, $attachments);
        remove_filter('wp_mail_content_type', array($this, 'DSERS_WOO_ALI_EMAIL_WPDOCS_SET_HTML_MAIL_CONTENT_TYPE'));
        return $result;
    }

    public function DSERS_WOO_ALI_EMAIL_WPDOCS_SET_HTML_MAIL_CONTENT_TYPE()
    {
        return 'text/html';
    }

    public function DSERS_WOO_ALI_EMAIL_WPMAIL_From_Name()
    {
        return get_bloginfo('name');
    }

    public function DSERS_WOO_ALI_EMAIL_Get_WC_Secret()
    {
        global $wpdb;

        return $wpdb->get_row($wpdb->prepare(
            "SELECT consumer_secret
             FROM `{$wpdb->prefix}woocommerce_api_keys`
             WHERE description LIKE %s ORDER BY key_id DESC",
            '%' . $wpdb->esc_like('DSers') . '%'
        ));
    }
}
