<?php

namespace DSERS_WOO_ALI;

class DSERS_WOO_ALI_Plugin
{
    private $path;
    public function ds_woo_getPath()
    {
        return $this->path;
    }

    private $url;
    public function ds_woo_getUrl()
    {
        return $this->url;
    }

    private $prefix;
    public function ds_woo_getPrefix()
    {
        return $this->prefix;
    }

    private $version = '1.4.6';
    public function ds_woo_getVersion()
    {
        return $this->version;
    }

    private $domain;
    public function ds_woo_getHomeDomain()
    {
        return $this->domain;
    }

    public function __construct()
    {
        $this->url = \plugin_dir_url(dirname(__FILE__));
        $this->path = \plugin_dir_path(dirname(__FILE__));
        $this->prefix = \plugin_basename(DS_WOO_MAKE_PATHS_RELATIVE_FILE);
        $this->domain = \get_home_url();
    }

    public function ds_woo_getResourcesURL()
    {
        return $this->ds_woo_getURL() . 'static/';
    }

    public function ds_woo_getApiURL()
    {
        return 'https://ac.dsers.com/api/v1/';
    }

    public function run()
    {
        if (wp_doing_ajax()) {
            $API = new \DSERS_WOO_ALI\DSERS_WOO_ALI_API($this);
            $API->run();
        } elseif (is_admin()) {
            $admin = new \DSERS_WOO_ALI\DSERS_WOO_PLUGIN_ADMIN($this);
            $admin->run();
        }

        $act = new \DSERS_WOO_ALI\Activation\DSERS_WOO_ALI_ACTIVATION_Requirement($this);
        $act->run();

        $comm = new \DSERS_WOO_ALI\DSERS_WOO_ALI_Common($this);
        $comm->run();
    }
}
